# AnotherLevelUp/fvwm2rc.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999 and Red Hat Software, Inc



# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.m4,v 1.4 1999/03/22 23:25:18 pbrown Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

#JTL#
# Need to see if we are running on RH5.2 or RH6.0!
# We assume we can tell if FVWM_MODULEDIR is set, that we are on RH6.0
# All places affected are marked with ifdef(`RH5'):
#
# ifdef(`RH5', `
# RH5 version of line(s)
# ', `
# RH6 version of line(s)
# ')

# Now see if we have RH5 still:

ifdef(`FVWM_MODULEDIR', `',`
define(`RH5', `YES')
')
#JTL#
#End of RH5/6 hack


###########################################################################
# Look at /tmp/fvwm* output to see what fvwm is defining things
# to be on your platform
#
# Need to muddle with comment characters so these lines don't get ignored by m4,
# but this needs to get passed through fvwm w/o wreaking havoc
changecom(%%%)
#FVWM-M4-Defines
#`SERVERHOST'=SERVERHOST
#`CLIENTHOST'=CLIENTHOST
#`HOSTNAME'=HOSTNAME
#`OSTYPE'=OSTYPE
#`USER'=USER
#`VERSION'=VERSION
#`VENDOR'=VENDOR
#`RELEASE'=RELEASE
#`WIDTH'=WIDTH
#`HEIGHT'=HEIGHT
#`X_RESOLUTION'=X_RESOLUTION
#`Y_RESOLUTION'=Y_RESOLUTION
#`PLANES'=PLANES
#`CLASS'=CLASS
#`COLOR'=COLOR
#`FVWM_VERSION'=FVWM_VERSION
#`OPTIONS'=OPTIONS
ifdef(`RH5', `
#`FVWMDIR'=FVWMDIR
', `
#`FVWMDIR'=FVWM_MODULEDIR
')
#
#`XRELEASE'=RELEASE
changecom(#)

# Get the user options.  This is the only file the casual user needs
# to worry about.
# define(`FVWM_USER_MODULE_PATH',`.')

##JTL#define(`ANOTHERLEVEL', `/etc/X11/AnotherLevel')
#JTL
#Find the location of this file from __file__
#and set ANOTHERLEVEL and ANOTHERLEVELIMAGES accordingly
changequote({, })
esyscmd(cat << . | bash
{
Here=}"__file__"
{
while test -L "\$Here"
do
  Here=\`find "\$Here" -printf %l\`
done
case "\$Here" in
/*) HereDir=\`dirname "\$Here"\` ;;
*/*) HereDir=\`dirname "\$Here"\` ;;
*) HereDir=\`which "\$Here"\`
   HereDir=\`dirname "\$HereDir"\` ;;
esac

echo "define({ANOTHERLEVEL}, {\$HereDir})"
HereDir=\`dirname "\$HereDir"\`
case "\$HereDir" in
/etc/X11)
  echo "define({ANOTHERLEVELICONS}, {})"
  echo "define({ANOTHERLEVELIMAGES}, {/usr/share/AnotherLevelUp/images})"
  echo "define({ANOTHERLEVELPREFERENCES}, {\$HereDir/AnotherLevelUp/SHARED_PREFERENCES})" ;;
*)
  echo "define({ANOTHERLEVELICONS}, {:\$HereDir/ICONS})"
  echo "define({ANOTHERLEVELIMAGES}, {\$HereDir/IMAGES})"
  echo "define({ANOTHERLEVELPREFERENCES}, {\$HereDir/SHARED_PREFERENCES})" ;;
esac
ANOTHERLEVELTTY=\`ps $$|grep $$|sed "s,^ *[0-9]*  *\\([^ ]*\\) .*$,\\1,"\`
echo "define({ANOTHERLEVELTTY}, {\$ANOTHERLEVELTTY})"
.
}
)
changequote(`, ')

changecom(%%%)
#`ANOTHERLEVEL'=ANOTHERLEVEL:
#`ANOTHERLEVELIMAGES'=ANOTHERLEVELIMAGES:
#`ANOTHERLEVELPREFERENCES'=ANOTHERLEVELPREFERENCES:
#`ANOTHERLEVELTTY'=ANOTHERLEVELTTY:
changecom(#)

#JTL#
#Make the user settings directory
exec mkdir HOME/.fvwm2dir


#JTL#This has changed quite a bit!
#Read given file argument, FNAME
#First check for HOME/.fvwm2dirAllThemes/FNAME
#else for HOME/.fvwm2dir/FNAME
#else for HOME/.FNAME -- backwards compatibility with AnotherLevel
#else for ANOTHERLEVEL/FNAME.m4
#AFTER reading that file, see if a POST file exists:
#Look for HOME/.fvwm2dirAllThemes/post_FNAME
#else for HOME/.fvwm2dir/post_FNAME

define(`readFile',
`#JTL#FILE: $1
 syscmd(`test -f $HOME'/.fvwm2dirAllThemes/$1)
 ifelse(sysval, 0,
   `sinclude(HOME/.fvwm2dirAllThemes/$1)'
 ,
   `syscmd(`test -f $HOME'/.fvwm2dir/$1)
    ifelse(sysval, 0,
      `sinclude(HOME/.fvwm2dir/$1)'
    ,
      `syscmd(`test -f $HOME'/.$1)
       ifelse(regexp($1, `fvwm2rc\.') sysval, `0 0',
         `sinclude(HOME/.$1)'
       ,
         `sinclude(ANOTHERLEVEL/$1.m4)'
       )
      '
    )
   '
 )
 syscmd(`test -f $HOME'/.fvwm2dirAllThemes/post_$1)
 ifelse(sysval, 0,
   `sinclude(HOME/.fvwm2dirAllThemes/post_$1)'
 ,
   `syscmd(`test -f $HOME'/.fvwm2dir/post_$1)
    ifelse(sysval, 0,
      `sinclude(HOME/.fvwm2dir/post_$1)'
    )
   '
 )
')


#JTL
# Experimental: using a cache file
# If settings have not changed since last time, then just copy saved file

changequote(,)
define(ALU_RC_FILE, esyscmd(echo -n `ls -t /tmp/fvwmrc*|head -1`))
changequote(`,')

readFile(`fvwm2rc.hostvariants')

ifdef(`ENABLE_CACHE',`

define(`CACHE_FILE', `.fvwm2dir/0-cache-'HOSTVARIANT)
define(`CACHE_SIGNATURE_FILE', `.fvwm2dir/0-cache-'HOSTVARIANT`-signature')

ifelse(esyscmd(cat CACHE_SIGNATURE_FILE),
esyscmd(cat .wm_style)USER WIDTH HEIGHT
OSTYPE VERSION RELEASE
X_RESOLUTION Y_RESOLUTION PLANES
CLASS COLOR FVWM_VERSION OPTIONS
ifdef(`RH5', `FVWMDIR', `FVWM_MODULEDIR')
, `
ifelse(esyscmd(ls -t .fvwm2dirAllThemes/[a-zA-Z]* .fvwm2dir/[a-zA-Z]* CACHE_FILE ANOTHERLEVEL/version-release.m4 |head -1),
CACHE_FILE`
', `
syscmd(xrdb -merge < .fvwm2dir/0-cache_xresources)
#esyscmd(sed "s|SetEnv ANOTHERLEVELUPTTY .*|SetEnv ANOTHERLEVELUPTTY ANOTHERLEVELTTY|g" < CACHE_FILE > ALU_RC_FILE)dnl
esyscmd(sed \
  -e "s|SetEnv ANOTHERLEVELUPTTY .*|SetEnv ANOTHERLEVELUPTTY ANOTHERLEVELTTY|g" \
  -e "s|Serverhost=.*`,'|Serverhost=SERVERHOST`,'|g" \
  -e "s|Clienthost=.*\"|Clienthost=CLIENTHOST\"|g" \
  -e "s|Hostname=[^`,']*`,'|Hostname=HOSTNAME`,'|g" \
  -e "s|Vendor=.*`,' Release|Vendor=VENDOR`,' Release|g" \
  < CACHE_FILE > ALU_RC_FILE)dnl
m4exit(0)dnl
')
')
')

#  -e "s|Ostype=.*`,'|Ostype=OSTYPE`,'|g" \
#  -e "s|\"Version=.*`,'|\"Version=VERSION`,'|g" \
#  -e "s|Release=.*\"|Release=RELEASE\"|g" \
#  -e "s|X_Resolution=.*`,'|X_Resolution=X_RESOLUTION`,'|g" \
#  -e "s|Y_Resolution=.*\"|Y_Resolution=Y_RESOLUTION\"|g" \
#  -e "s|Planes=[^`,']*`,'|Planes=PLANES`,'|g" \
#  -e "s|Class=.*`,'|Class=CLASS`,'|g" \
#  -e "s|Color=.*\"|Color=COLOR\"|g" \
#  -e "s|Fvwm_Version=.*`,'|Fvwm_Version=FVWM_VERSION`,'|g" \
#  -e "s|Options=.*\"|Options=OPTIONS\"|g" \


# remove cache signature file in case this set up is not completed
syscmd(rm CACHE_SIGNATURE_FILE)

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-1.jpeg)
')

#JTL
#Now define corresponding environment variables
ifdef(`RH5', `
',`
SetEnv `ANOTHERLEVELUP' ANOTHERLEVEL
SetEnv `ANOTHERLEVELUPIMAGES' ANOTHERLEVELIMAGES
SetEnv `ANOTHERLEVELUPPREFERENCES' ANOTHERLEVELPREFERENCES
SetEnv `ANOTHERLEVELUPTTY' ANOTHERLEVELTTY
')

#JTL#Read the release date as put on the start menu
include(ANOTHERLEVEL`/version-release.m4')

#JTL#These used to be below...
readFile(`fvwm2rc.macros')

# To keep .fvwm2rc.defines clean, we define default values as necessary 
# through a separate file
readFile(`fvwm2rc.defaults')
readFile(`fvwm2rc.defines')

#JTL#
#Now merge in any Xresources
TraceForErrors(`Making X Resources...')
ifelse(WM_STYLE, `FVWM95', `
syscmd(ANOTHERLEVEL/bin/xresources -all)
',`
syscmd(ANOTHERLEVEL/bin/xresources -default)
')

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-2.jpeg)
')

# Now read some more user options
#JTL#
#First some specific files created by scripts and menus
ifelse(WM_STYLE, `FVWM95', `
readFile(scripts_XSnow)
readFile(scripts_XEyes)
readFile(scripts_XEarth)
')

#JTL#
#Now the most general user options
readFile(`fvwm2rc.options')

# Now read in some interesting macros...
#JTL#A bit too late; want to use them above! Moved up.
#JTL#readFile(`fvwm2rc.macros')

###############################################################################
# Set our all-important paths.
# Note that your "executables" path (the one your shell uses to search for
# programs it tries to exec) is set *before* fvwm starts.  Usually it is
# set by .xinitrc or .xsession, which hopefully sources some environment
# settings files like /etc/env, /etc/profile, ~/.env, ~/.profile, etc.#
ifdef(`RH5', `
ModulePath FVWMDIR/
', `
ModulePath FVWM_MODULEDIR/
')
PixmapPath USER_PIXMAP_PATH
IconPath   USER_ICON_PATH

# This is the real magic of AnotherLevel - decorations...
# To date it is supposed to work for Win95, Mwm, and Afterstep
TraceForErrors(`Including_decors...')
readFile(`fvwm2rc.decors')

#JTL#
changecom(%%%)
AddToFunc "SetBackground"
ifelse(BG_MODE, `Solid',   `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; xsetroot -solid "BG_COLOR"', `')
changequote([,])
ifelse(BG_MODE, [Bitmap], [+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; export histchars=""; ANOTHERLEVEL/bin/load-root-image "`echo "BG_BITMAP" | sed "s,^ ,," | sed "s, $,,"`" "BG_COLOR"], [])
changequote(`,')
ifelse(BG_MODE, `Moving', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; xlock -nice NICELEVEL -mode BG_MOVING -nolock -inroot', `')
ifelse(BG_MODE, `Mixture', `+ "I" Exec ANOTHERLEVEL/bin/kill-all-proc xlock; ANOTHERLEVEL/bin/load-root-image "BG_COLOR" "WINBACK_COLOR"', `')
changecom(#)

###########################################################################
#
# Set up the basic colors
#

###########################################################################
# Stuff to do at start-up
# User initialization is done in .fvwm2rc.init, included at bottom.
##########

AddToFunc "InitFunction"
+ "I" SetupFunction
+ "I" StartupFunction
+ "I" EndSetupFunction

AddToFunc "RestartFunction"
+ "I" SetupFunction
+ "I" EndSetupFunction

###########################################################################
# Set the decoration styles and window options for specific apps
# Order does matter... if compatible styles are set for a single window
# in multiple Style commands, then the styles are ORed together. If
# conflicting styles are set, the last one specified is used.

###########################################################################
#
# Include all the other support files
#

# Various complex functions
TraceForErrors(`Including_complex functions...')
readFile(`fvwm2rc.functions')

# Various key bindings
TraceForErrors(`Including_key bindings...')
readFile(`fvwm2rc.keys')

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-3.jpeg)
')

# Creation of the menus
TraceForErrors(`Including_menus...')
readFile(`fvwm2rc.menus')
#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-7.jpeg)
')

# These commands should command before any menus or functions are defined,
# and before the internal pager is started.
TraceForErrors(`Including_defstyles...')
readFile(`fvwm2rc.defstyles')

# Module settings
TraceForErrors(`Including_modules...')
readFile(`fvwm2rc.modules')

# User initialization
TraceForErrors(`Including_init...')
readFile(`fvwm2rc.init')

###########################################################################
# Local Variables:
# rm-trailing-spaces: t
# page-delimiter: "^#####"
# End:
TraceForErrors(`Done')

#JTL save output file to cache
changecom(%%%)
ifdef(`ENABLE_CACHE',`
syscmd(egrep -v "^ *#|^ *$" ALU_RC_FILE > CACHE_FILE)
syscmd(cp .wm_style CACHE_SIGNATURE_FILE;
       echo "USER WIDTH HEIGHT" >> CACHE_SIGNATURE_FILE;
       echo "OSTYPE VERSION RELEASE" >> CACHE_SIGNATURE_FILE;
       echo "X_RESOLUTION Y_RESOLUTION PLANES" >> CACHE_SIGNATURE_FILE;
       echo "CLASS COLOR FVWM_VERSION OPTIONS">> CACHE_SIGNATURE_FILE;
       echo "ifdef(`RH5', `FVWMDIR', `FVWM_MODULEDIR')" >> CACHE_SIGNATURE_FILE)
')
